]> git.armaanb.net Git - opendoas.git/blobdiff - configure
Replace build/installation instructions with discouragements
[opendoas.git] / configure
index c5a4c397450539fe98c041b2db37f12434ea2f0e..1f92f0175d6613e7ba8359a3c17bf14d4e3c4e43 100755 (executable)
--- a/configure
+++ b/configure
@@ -15,7 +15,6 @@ usage: configure [options]
   --datadir=DIR          architecture-independent data files [PREFIX/share]
   --mandir=DIR           manual pages [DATADIR/man]
   --sysconfdir=DIR       directory for configuration files [/etc]
-  --pamdir=DIR           PAM directory [SYSCONFDIR/pam.d]
 
   --build=build-alias    a cpu-vendor-opsys for the system where the application will be built
   --host=host-alias      a cpu-vendor-opsys for the system where the application will run
@@ -25,13 +24,23 @@ usage: configure [options]
   --enable-static        prepare for static build
 
   --without-pam          disable pam support
-  --without-pam          disable shadow support
+  --without-shadow       disable shadow support
+
+  --with-timestamp       enable timestamp support
+
+  --uid-max=NUM          set UID_MAX (default 65535)
+  --gid-max=NUM          set GID_MAX (default 65535)
 
   --help, -h             display this help and exit
 EOF
        exit 0
 }
 
+# defaults
+WITHOUT_TIMESTAMP=yes
+UID_MAX=65535
+GID_MAX=65535
+
 for x; do
        opt=${x%%=*}
        var=${x#*=}
@@ -42,7 +51,6 @@ for x; do
        --datadir) SHAREDIR=$var ;;
        --mandir) MANDIR=$var ;;
        --sysconfdir) SYSCONFDIR=$var ;;
-       --pamdir) PAMDIR=$var ;;
        --build) BUILD=$var ;;
        --host) HOST=$var ;;
        --target) TARGET=$var ;;
@@ -52,27 +60,24 @@ for x; do
        --with-shadow) WITHOUT_SHADOW=; WITHOUT_PAM=yes ;;
        --without-pam) WITHOUT_PAM=yes ;;
        --without-shadow) WITHOUT_SHADOW=yes ;;
+       --with-timestamp) WITHOUT_TIMESTAMP= ;;
+       --without-timestamp) WITHOUT_TIMESTAMP=yes ;;
+       --uid-max) UID_MAX=$var ;;
+       --gid-max) UID_MAX=$var ;;
        --help|-h) usage ;;
        *) die "Error: unknown option $opt" ;;
        esac
 done
 
 CONFIG_MK=config.mk
-rm -f "$CONFIG_MK"
+CONFIG_H=config.h
+rm -f "$CONFIG_MK" "$CONFIG_H"
 
-# : ${VERSION:="$(git describe --dirty --tags --long --always)"}
-: ${VERSION:="0.3.2"}
+cat <<! >$CONFIG_H
+#ifndef CONFIG_H
+#define CONFIG_H
 
-cat <<EOF >>$CONFIG_MK
-PREFIX   ?=    ${PREFIX:="/usr"}
-EPREFIX  ?=    ${EPREFIX:="${PREFIX}"}
-BINDIR   ?=    ${BINDIR:="${PREFIX}/bin"}
-SHAREDIR ?=    ${SHAREDIR:="${PREFIX}/share"}
-MANDIR   ?=    ${MANDIR:="${SHAREDIR}/man"}
-SYSCONFDIR?=   ${SYSCONFDIR:="/etc"}
-PAMDIR   ?=    ${PAMDIR:="${SYSCONFDIR}/pam.d"}
-CFLAGS   +=    -DVERSION="\"${VERSION}\""
-EOF
+!
 
 if [ -z "$BUILD" ]; then
        BUILD="$(uname -m)-unknown-$(uname -s | tr '[:upper:]' '[:lower:]')"
@@ -101,15 +106,50 @@ OS_CFLAGS="-D__${OS}__"
 
 case "$OS" in
        linux)
-               OS_CFLAGS="$OS_CFLAGS -D_DEFAULT_SOURCE -D_GNU_SOURCE -DUID_MAX=60000 -DGID_MAX=60000"
-               printf 'CURDIR   :=     .\n' >>$CONFIG_MK
-               [ -z "$WITHOUT_PAM" ] && \
-                       printf 'PAM_DOAS  =     pam.d__doas__linux\n' >>$CONFIG_MK
+               printf 'Setting UID_MAX\t\t\t\t%d.\n' "$UID_MAX" >&2
+               printf '#define UID_MAX %s\n' "$UID_MAX" >>$CONFIG_H
+               printf 'Setting GID_MAX\t\t\t\t%d.\n' "$GID_MAX" >&2
+               printf '#define GID_MAX %s\n' "$GID_MAX" >>$CONFIG_H
+               OS_CFLAGS="$OS_CFLAGS -D_DEFAULT_SOURCE -D_GNU_SOURCE"
+               ;;
+       netbsd)
+               OS_CFLAGS="$OS_CFLAGS -D_OPENBSD_SOURCE"
+               printf 'LDLIBS +=       -lutil\n' >>$CONFIG_MK
+               : ${BINGRP:=wheel}
+               ;;
+       freebsd)
+               printf 'LDLIBS +=       -lutil\n' >>$CONFIG_MK
+               : ${BINGRP:=wheel}
+               ;;
+       darwin)
+               : ${BINGRP:=wheel}
                ;;
 esac
 
+: ${PREFIX:=/usr/local}
+: ${EPREFIX:=${PREFIX}}
+: ${BINDIR:=${PREFIX}/bin}
+: ${SHAREDIR:=${PREFIX}/share}
+: ${MANDIR:=${SHAREDIR}/man}
+: ${SYSCONFDIR:=/etc}
+: ${BINMODE:=4755}
+: ${BINOWN:=root}
+: ${BINGRP:=root}
+
+cat <<EOF >>$CONFIG_MK
+PREFIX   ?=    ${PREFIX}
+EPREFIX  ?=    ${EPREFIX}
+BINDIR   ?=    ${BINDIR}
+SHAREDIR ?=    ${SHAREDIR}
+MANDIR   ?=    ${MANDIR}
+SYSCONFDIR?=   ${SYSCONFDIR}
+BINMODE  ?=    ${BINMODE}
+BINOWN  ?=     ${BINOWN}
+BINGRP  ?=     ${BINGRP}
+EOF
+
 [ -n "$OS_CFLAGS" ] && \
-       printf 'CFLAGS   +=     %s\n' "$OS_CFLAGS" >>$CONFIG_MK
+       printf 'OS_CFLAGS   +=  %s\n' "$OS_CFLAGS" >>$CONFIG_MK
 
 [ -n "$DEBUG" ] && \
        printf 'CFLAGS   +=     -O0 -g\n' >>$CONFIG_MK
@@ -117,10 +157,14 @@ esac
 [ -n "$BUILD_STATIC" ] && \
        printf 'CFLAGS   +=     -static\n' >>$CONFIG_MK
 
-# Add CPPFLAGS/CFLAGS/LDFLAGS to CC for testing features
-XCC="${CC:=cc} $CFLAGS $OS_CFLAGS $CPPFLAGS $LDFLAGS"
+# Add CPPFLAGS/CFLAGS/LDFLAGS/LDLIBS to CC for testing features
+XCC="${CC:=cc} $CFLAGS $OS_CFLAGS $CPPFLAGS $LDFLAGS $LDLIBS"
 # Make sure to disable --as-needed for CC tests.
-XCC="$XCC -Wl,--no-as-needed"
+
+case "$OS" in
+       darwin) ;;
+       *) XCC="$XCC -Wl,--no-as-needed" ;;
+esac
 
 check_func() {
        func="$1"; src="$2"; shift 2
@@ -129,32 +173,19 @@ check_func() {
        $XCC "_$func.c" -o "_$func" 2>/dev/null
        ret=$?
        rm -f "_$func.c" "_$func"
+       upperfunc="$(printf '%s\n' "$func" | tr '[[:lower:]]' '[[:upper:]]')"
        if [ $ret -eq 0 ]; then
                printf 'yes.\n' >&2
-               upperfunc="$(printf '%s\n' "$func" | tr '[[:lower:]]' '[[:upper:]]')"
-               printf 'CFLAGS   +=     -DHAVE_%s\n' "$upperfunc" >>$CONFIG_MK
+               printf '#define HAVE_%s\n' "$upperfunc" >>$CONFIG_H
                return 0
        else
+               printf '/* #define HAVE_%s */\n' "$upperfunc" >>$CONFIG_H
                printf 'no.\n' >&2
                return 1
        fi
 }
 
 authmethod() {
-       #
-       # Check for bsd_auth.h.
-       #
-       src='
-#include <bsd_auth.h>
-int main(void) {
-       return 0;
-}'
-       check_func "bsd_auth_h" "$src" && {
-               have_bsd_auth_h=1
-               printf 'bsd\n'
-               return 0
-       }
-
        #
        # Check for pam_appl.h.
        #
@@ -165,7 +196,8 @@ int main(void) {
 }'
        [ -z "$WITHOUT_PAM" ] && check_func "pam_appl_h" "$src" && {
                printf 'SRCS     +=     pam.c\n' >>$CONFIG_MK
-               printf 'LDFLAGS  +=     -lpam\n' >>$CONFIG_MK
+               printf 'LDLIBS +=       -lpam\n' >>$CONFIG_MK
+               printf '#define USE_PAM\n' >>$CONFIG_H
                printf 'pam\n'
                return 0
        }
@@ -179,7 +211,9 @@ int main(void) {
        return 0;
 }'
        [ -z "$WITHOUT_SHADOW" ] && check_func "shadow_h" "$src" && {
-               printf 'LDFLAGS  +=     -lcrypt\n' >>$CONFIG_MK
+               printf 'SRCS     +=     shadow.c\n' >>$CONFIG_MK
+               printf 'LDLIBS +=       -lcrypt\n' >>$CONFIG_MK
+               printf '#define USE_SHADOW\n' >>$CONFIG_H
                printf 'shadow\n'
                return 0
        }
@@ -187,6 +221,16 @@ int main(void) {
        return 1
 }
 
+persistmethod() {
+       [ -z "$WITHOUT_TIMESTAMP" ] && {
+               printf '#define USE_TIMESTAMP\n' >>$CONFIG_H
+               printf 'SRCS    += timestamp.c\n' >>$CONFIG_MK
+               printf 'timestamp\n'
+               return 0
+       }
+       return 1
+}
+
 #
 # Check for explicit_bzero().
 #
@@ -197,7 +241,7 @@ int main(void) {
        return 0;
 }'
 check_func "explicit_bzero" "$src" || {
-       printf 'OPENBSD  +=     explicit_bzero.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/explicit_bzero.c\n' >>$CONFIG_MK
 }
 
 #
@@ -212,7 +256,7 @@ int main(void) {
        return 0;
 }'
 check_func "strlcat" "$src" || {
-       printf 'OPENBSD  +=     strlcat.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/strlcat.c\n' >>$CONFIG_MK
 }
 
 #
@@ -227,7 +271,7 @@ int main(void) {
        return 0;
 }'
 check_func "strlcpy" "$src" || {
-       printf 'OPENBSD  +=     strlcpy.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/strlcpy.c\n' >>$CONFIG_MK
 }
 
 #
@@ -240,20 +284,21 @@ int main(void) {
        return 0;
 }'
 check_func "errc" "$src" || {
-       printf 'OPENBSD  +=     errc.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/errc.c\n' >>$CONFIG_MK
 }
 
 #
 # Check for verrc().
 #
 src='
+#include <stddef.h>
 #include <err.h>
 int main(void) {
-       verrc(0, 0, "");
+       verrc(0, 0, "x", NULL);
        return 0;
 }'
 check_func "verrc" "$src" || {
-       printf 'OPENBSD  +=     verrc.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/verrc.c\n' >>$CONFIG_MK
 }
 
 #
@@ -266,7 +311,7 @@ int main(void) {
        return 0;
 }'
 check_func "setprogname" "$src" || {
-       printf 'OPENBSD  +=     progname.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/progname.c\n' >>$CONFIG_MK
 }
 
 #
@@ -280,7 +325,7 @@ int main(void) {
        return 0;
 }'
 check_func "readpassphrase" "$src" || {
-       printf 'OPENBSD  +=     readpassphrase.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/readpassphrase.c\n' >>$CONFIG_MK
 }
 
 #
@@ -294,7 +339,7 @@ int main(void) {
        return 0;
 }'
 check_func "strtonum" "$src" || {
-       printf 'OPENBSD  +=     strtonum.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/strtonum.c\n' >>$CONFIG_MK
 }
 
 #
@@ -307,7 +352,7 @@ int main(void) {
        return 0;
 }'
 check_func "reallocarray" "$src" || {
-       printf 'OPENBSD  +=     reallocarray.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/reallocarray.c\n' >>$CONFIG_MK
 }
 
 #
@@ -321,7 +366,7 @@ int main(void) {
        return 0;
 }'
 check_func "execvpe" "$src" || {
-       printf 'OPENBSD  +=     execvpe.o\n' >>$CONFIG_MK
+       printf 'SRCS += libopenbsd/execvpe.c\n' >>$CONFIG_MK
 }
 
 #
@@ -333,23 +378,157 @@ int main(void) {
        setresuid(0, 0, 0);
        return 0;
 }'
-check_func "setresuid" "$src" || {
-       printf 'OPENBSD  +=     setresuid.o\n' >>$CONFIG_MK
-}
+check_func "setresuid" "$src"
+have_setresuid=$?
+
+#
+# Check for setresgid().
+#
+src='
+#include <unistd.h>
+int main(void) {
+       setresgid(0, 0, 0);
+       return 0;
+}'
+check_func "setresgid" "$src"
+have_setresgid=$?
+
+if [ $have_setresuid -eq 1 -o $have_setresgid -eq 1 ]; then
+       printf 'SRCS += libopenbsd/bsd-setres_id.c\n' >>$CONFIG_MK
+fi
+
+#
+# Check for setreuid().
+#
+src='
+#include <unistd.h>
+int main(void) {
+       setreuid(0, 0);
+       return 0;
+}'
+check_func "setreuid" "$src"
+
+
+#
+# Check for setregid().
+#
+src='
+#include <unistd.h>
+int main(void) {
+       setregid(0, 0);
+       return 0;
+}'
+check_func "setregid" "$src"
 
 #
-# Check for pledge().
+# Check for closefrom().
 #
 src='
 #include <unistd.h>
 int main(void) {
-       pledge("", NULL);
+       closefrom(0);
        return 0;
 }'
-check_func "pledge" "$src" || {
-       printf 'OPENBSD  +=     pledge-noop.o\n' >>$CONFIG_MK
+check_func "closefrom" "$src" || {
+       printf 'SRCS += libopenbsd/closefrom.c\n' >>$CONFIG_MK
 }
 
+#
+# Check for sysconf().
+#
+src='
+#include <unistd.h>
+int main(void) {
+       (void)sysconf(0);
+       return 0;
+}'
+check_func "sysconf" "$src"
+
+#
+# Check for dirfd().
+#
+src='
+#include <dirent.h>
+int main(void) {
+       (void)dirfd(0);
+       return 0;
+}'
+check_func "dirfd" "$src"
+
+#
+# Check for fcntl.h.
+#
+src='
+#include <fcntl.h>
+int main(void) {
+       return 0;
+}'
+check_func "fcntl_h" "$src"
+
+#
+# Check for F_CLOSEM.
+#
+src='
+#include <fcntl.h>
+#ifndef F_CLOSEM
+#error no F_CLOSEM
+#endif
+int main(void) {
+       return 0;
+}'
+check_func "F_CLOSEM" "$src"
+
+#
+# Check for dirent.h.
+#
+src='
+#include <dirent.h>
+int main(void) {
+       return 0;
+}'
+check_func "dirent_h" "$src"
+
+#
+# Check for sys/ndir.h.
+#
+src='
+#include <sys/ndir.h>
+int main(void) {
+       return 0;
+}'
+check_func "sys_ndir_h" "$src"
+
+#
+# Check for sys/dir.h.
+#
+src='
+#include <sys/dir.h>
+int main(void) {
+       return 0;
+}'
+check_func "sys_dir_h" "$src"
+
+#
+# Check for ndir.h.
+#
+src='
+#include <ndir.h>
+int main(void) {
+       return 0;
+}'
+check_func "ndir_h" "$src"
+
+#
+# Check for login_cap.h.
+#
+src='
+#include <sys/types.h>
+#include <login_cap.h>
+int main(void) {
+       return 0;
+}'
+check_func "login_cap_h" "$src"
+
 #
 #
 #
@@ -359,7 +538,7 @@ int main(void){return 0;}
 __attribute__((__unused__)) static void foo(void){return;}
 '
 check_func "__attribute__" "$src" || {
-       printf 'CFLAGS  +=      -DNO_ATTRIBUTE_ON_RETURN_TYPE=1\n' >>$CONFIG_MK
+       printf 'OS_CFLAGS       +=      -DNO_ATTRIBUTE_ON_RETURN_TYPE=1\n' >>$CONFIG_MK
 }
 
 auth=$(authmethod)
@@ -369,3 +548,14 @@ else
        printf 'Error auth method\t\t\n' >&2
        exit 1
 fi
+
+persist=$(persistmethod)
+if [ $? -eq 0 ]; then
+       printf 'Using persist method\t\t\t%s.\n' "$persist" >&2
+else
+       printf 'Using persist method\t\t\tnone.\n' >&2
+fi
+
+printf '#define DOAS_CONF "%s/doas.conf"\n' "${SYSCONFDIR}" >>$CONFIG_H
+
+printf '\n#endif /* CONFIG_H */\n' >>$CONFIG_H